## Data 

* `quarterly.csv`: FRED-QD database from 1959 Q1 to 2023 Q2.
* `monthly.csv`: FRED-MD database from 1959 January to 2023 July. 
* `date_recession.RData`: Recession periods documented by NBER (for producing graphs only).

## R Scripts

Below are demonstrations of the R programs in the `RScripts` folder.

* `BoostedHP.R`: An R function that implements boosted HP filter. 
* `GDP.R`: Replicate Figure 1 with plots of the trend, cycle, and raw data for the USA's real GDP. The outputs are stored as `graphs/GDP_trend.pdf`  and `graphs/GDP_cycle.pdf` .
* `GDP_21C.R`: Replicate Figure 2 with a zoom-in version of Figure 1 after 2000. The outputs are stored as `graphs/GDP_trend_21C.pdf`  and `graphs/GDP_cycle_21C.pdf` .
* `cycle.R`: Generate cyclical components for all quarterly and monthly data. Intermediate results are stored in the "RDS" folder.
* `plot_cycle.R`: Replicate Figure 3 with aggregate cycles from FRED-QD. The output is stored as `graphs/aggregate_quarter.pdf`.
* `plot_cycle_month.R`: Replicate Figure 4 with FRED-MD. The output is stored as `graphs/aggregate_month.pdf`.
* `response_trend.R` and `plot_HRF_multiple_h.R` : Replicate Figure 5 in the Conclusion section. The outputs are stored as `graphs/response_trend.pdf` and `graphs/conclusion.pdf`.

