
rm(list = ls())

library(tseries)
library(magrittr)
library(xts)
library(knitr)
library(neverhpfilter)
library(dynlm)
library(LongMemoryTS)
#source("BoostedHP_pub.R")
setwd("~/bHP_simulation")
source("DGP_sto.R")
source("Simul_HP.R")
source("BoostedHP.R")
## self defined functions ##############

compare <- function(x, trend){
  
  x = as.ts(x)
  n = length(x)
  
  d0 = BoostedHP( x, lambda=1.6e-5 * n^4, iter = FALSE)$trend
  
  # bhp.adf = BoostedHP( x, lambda=1600, iter = TRUE, test_type =  "adf", sig_p = 0.05, Max_Iter = 200) 
  # d1 = bhp.adf$trend
  # stop.adf005 = bhp.adf$iter_num
  # 
  # 
  # bhp.adf = BoostedHP( x, lambda=1600, iter = TRUE, test_type =  "adf", sig_p = 0.01, Max_Iter = 200) 
  # d2 = bhp.adf$trend
  # stop.adf001 = bhp.adf$iter_num
  
  bhp.bic = BoostedHP( x, lambda=1.6e-5 * n^4, iter = TRUE, test_type =  "BIC", Max_Iter = 200)
  d3 = bhp.bic$trend
  stop.bic = bhp.bic$iter_num
  
  reg = dynlm( x  ~ L(x, c(1:4) ) )
  d4 = c( rep(NA,4), predict(reg) )
  stop.adf001 = stop.bic
  stop.adf005 = stop.bic
  d1 = d3
  d2 = d3
  dd = cbind( x, d0, d1, d2, d3, d4 ) 
  
  trim_dd = dd[ 5:(n-4),  ]
  
  cycle = x - trend 
  
  
  return( list(MSE = colMeans( (trim_dd[,2:6] - trend[ 5:(n-4) ] )^2, na.rm = TRUE ), 
               MSE.40 = colMeans( (trim_dd[ (n-47):(n-8),2:6] - trend[ (n-43):(n-4) ] )^2, na.rm = TRUE ), 
               stop = c(stop.adf005, stop.adf001, stop.bic) )   )
  
}
##############################################

set.seed(200)

Rep = 5000

n = 600
Title = "Adaptive"
Trend = "LUR"
Simul_HP(n, Rep, Title, Trend)